package cn.skcks.study.springcloud.kafka.producer.controller;

import cn.skcks.study.springcloud.kafka.common.model.dto.Message;
import cn.skcks.study.springcloud.utils.JsonUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

@Slf4j
@RestController
@AllArgsConstructor
public class SimpleController {
    private KafkaTemplate<Object, String> kafkaTemplate;
    final static String TOPIC_NAME = "test";

    @GetMapping("/api/v2/{num}")
    public void sendMessage1(@PathVariable("num") String num) {

        Message message = new Message();
        message.setData("这是一个消息,num="+num);

        kafkaTemplate.send(TOPIC_NAME,num, JsonUtils.toJson(message)).addCallback(success->{
            log.debug("消息 {} 发送成功",message);
        },failure->{
            log.info("发送消息失败 {}",failure.getMessage());
        });
    }
}
